from mcmc import MetropolisHastings
import segmodels
import segdata
import matplotlib.pyplot as plt
import numpy as np
import pickle

# remove tf log messages:
import os
os.environ["TF_CPP_MIN_LOG_LEVEL"] = "2"


if __name__ == '__main__':

    ## READ DATA

    # change name here and comment the right aberrations
    # f="results/metropolis_2021-05-14_array"
    f="results/metropolis_2021-05-10_chemostat_arraytmp"
    # f="results/metropolis_2021-05-28_segregostat_array"
    min_num=3


    # metro=MetropolisHastings.read(f)

    ## create array to save min models later
    with open(f+'/save_'+str(min_num)+'_models.pkl', 'rb') as input:
        best_models=pickle.load(input)
        input.close()
        del input

    best_models=best_models[0,:]

    for i,mod in enumerate(best_models):
        print(i)
        print(mod.aggregate()[0])

    mini=np.array([best_models[0],best_models[3],best_models[7]])

    for i,mod in enumerate(mini):
        print(i)
        print(mod.aggregate())

    d=mini[0].data[0]

    # plot proportions

    for i,mod in enumerate(mini):
        fig, ax=plt.subplots(figsize=(4,4))
        p=segdata.Plot(d)
        p.plot_count(ax, d)

        mod.models[0].plot_prop(ax)

        name='figures/model_4_'+str(i)+'_prop.pdf'
        plt.savefig(name, bbox_inches='tight')


        plt.close('all')


    for i,mod in enumerate(mini):
        fig, ax=plt.subplots(figsize=(4,4))
        p=segdata.Plot(d)


        plt.plot(mod.models[0].sol[0,:],np.sum(mod.models[0].sol[1:4,:],
                axis=0),
                label='Cell concentration')

        plt.plot(mod.models[0].sol[0,:],mod.models[0].sol[2,:],
                label='Arabinose user concentration')

        plt.plot(mod.models[0].sol[0,:],
                mod.models[0].sol[1,:]+mod.models[0].sol[3,:],
                label='Glucose user concentration')

        ax.legend()
        ax.set_xlabel('Time [h]')
        ax.set_ylabel('Cell concentration [g/L]')
        name='figures/model_4_'+str(i)+'_cell.pdf'
        plt.savefig(name, bbox_inches='tight')


        plt.close('all')

    for i,mod in enumerate(mini):
        fig, ax=plt.subplots(figsize=(4,4))
        p=segdata.Plot(d)

        plt.plot(mod.models[0].sol[0,:],mod.models[0].sol[4,:],
                label='Arabinose concentration')

        plt.plot(mod.models[0].sol[0,:],
                 mod.models[0].sol[5,:],
                label='Glucose concentration')

        ax.legend()
        ax.set_xlabel('Time [h]')
        ax.set_ylabel('Concentration [g/L]')

        name='figures/model_4_'+str(i)+'_sugar.pdf'
        plt.savefig(name, bbox_inches='tight')


        plt.close('all')
