from mcmc import MetropolisHastings
import segmodels
import segdata
import matplotlib.pyplot as plt
import numpy as np
import pickle
from file_list import l
from metrowrapper import MetroWrapper


# remove tf log messages:
import os
os.environ["TF_CPP_MIN_LOG_LEVEL"] = "2"


if __name__ == '__main__':

    ## READ DATA

    # change name here and comment the right aberrations
    # f="results/metropolis_2021-05-14_array"
    f="results/metropolis_2021-05-28_segregostat_array" # ran

    model_number=13
    min_num=3

    ## create array to save min models later
    with open(f+'/save_'+str(min_num)+'_models.pkl', 'rb') as input:
        best_models=pickle.load(input)
        input.close()
        del input

    # best_models:
    # lines: 0->20 corresponds to models 4->23
    # columns: 3 min models for each 3 runs then 3 mean(min models) per run
    #          then mean(mean(min models)) for all runs.


    ## eliminate a few models that had errors
    ## (the code doesn't comple for some models, reason unknown)
    # # for f="results/metropolis_2021-05-14_array"
    # best_models[9,3]=best_models[9,2]
    # best_models[9,4]=best_models[9,2]
    # best_models[8,3]=best_models[8,2]
    # best_models[8,4]=best_models[8,2]
    # best_models[8,5]=best_models[8,2]
    # best_models[8,10]=best_models[8,2]

    ## get the min models per line
    min_models=np.empty((20,), dtype=object)
    for i in range(20):
        min_models[i]=best_models[i,0]
        for mod in best_models[i,1:]:
            if mod.aggregate()[0]<min_models[i].aggregate()[0]:
                min_models[i]=mod

    del best_models


    d=segdata.Data(l[0])
    d.sanitize()

    b1=min_models[model_number-4].BASE_MOD.memory.clone()
    b2=b1.clone()
    b2.dta=0.5
    b2.dtg=0.1
    i1,b1=segmodels.differential.set_contri(b1, model_number)
    i2,b2=segmodels.differential.set_contri(b2, model_number+2)
    mod1=segmodels.Model(b1,i1)
    mod2=segmodels.Model(b2,i2)
    wrapper2=MetroWrapper(mod2, np.array([d]))
    wrapper1=MetroWrapper(mod1, np.array([d]))

    print(1)
    wrapper1.run_once()
    print(2)
    wrapper2.run_once()
    print('done')

    print(wrapper1.aggregate())
    print(wrapper2.aggregate())

    fig,ax=plt.subplots(figsize=(4,4))
    p=segdata.Plot(d)
    p.plot_count(ax, d)
    wrapper1.models[0].plot_prop(ax)
    wrapper2.models[0].plot_prop(ax)
    p.add_regulation(ax, d)
    t='_'.join(segmodels.differential.get_contri(model_number))
    name=f+'/'+str(model_number)+'_'+t+'_test_delay_.pdf'
    plt.savefig(name, bbox_inches='tight')
