from mcmc import MetropolisHastings
import segmodels
import segdata
import matplotlib.pyplot as plt
import numpy as np
import pickle

# remove tf log messages:
import os
os.environ["TF_CPP_MIN_LOG_LEVEL"] = "2"


if __name__ == '__main__':

    ## READ DATA

    # change name here and comment the right aberrations
    f="results/metropolis_2021-05-14_array"
    # f="results/metropolis_2021-05-10_chemostat_arraytmp"
    # f="results/metropolis_2021-05-28_segregostat_array"
    min_num=3

    ## eliminate a few models that had errors
    ## (errors appeared at first then the code was corrected)
    # for f="results/metropolis_2021-05-14_array"
    # best_models[9,3]=best_models[9,2]
    # best_models[9,4]=best_models[9,2]
    # best_models[8,3]=best_models[8,2]
    # best_models[8,4]=best_models[8,2]
    # best_models[8,5]=best_models[8,2]
    # best_models[8,10]=best_models[8,2]


    # metro=MetropolisHastings.read(f)

    ## create array to save min models later
    with open(f+'/save_'+str(min_num)+'_models.pkl', 'rb') as input:
        best_models=pickle.load(input)
        input.close()
        del input

    # best_models:
    # lines: 0->20 corresponds to models 4->23
    # columns: 3 min models for each 3 runs then 3 mean(min models) per run
    #          then mean(mean(min models)) for all runs.

    ## get the min models per line
    min_models=np.empty((20,), dtype=object)
    for i in range(20):
        min_models[i]=best_models[i,0]
        for mod in best_models[i,1:]:
            if mod.aggregate()[0]<min_models[i].aggregate()[0]:
                min_models[i]=mod
