from mcmc import MetropolisHastings
import segmodels
import segdata
import matplotlib.pyplot as plt
import numpy as np
import pickle

# remove tf log messages:
import os
os.environ["TF_CPP_MIN_LOG_LEVEL"] = "2"


if __name__ == '__main__':

    ## READ DATA

    # make one graph of model 9

    # change name here and comment the right aberrations
    # f="results/metropolis_2021-05-14_array"
    # f="results/metropolis_2021-05-10_chemostat_arraytmp"
    f="results/metropolis_2021-05-28_segregostat_array"
    min_num=3



    # metro=MetropolisHastings.read(f)

    ## create array to save min models later
    with open(f+'/save_'+str(min_num)+'_models.pkl', 'rb') as input:
        best_models=pickle.load(input)
        input.close()
        del input

    # best_models:
    # lines: 0->20 corresponds to models 4->23
    # columns: 3 min models for each 3 runs then 3 mean(min models) per run
    #          then mean(mean(min models)) for all runs.

    ## get the min models per line
    min_models=np.empty((20,), dtype=object)
    for i in [5]: # equivalent to model 9
        min_models[i]=best_models[i,0]
        for mod in best_models[i,1:]:
            if mod.aggregate()[0]<min_models[i].aggregate()[0]:
                min_models[i]=mod

    i=0
    mod=min_models[5]
    del min_models
    del best_models

    d=mod.data[0]

    j=5

    t='_'.join(segmodels.differential.get_contri(j+4))
    t=t.replace(' ','')

    fig, ax = plt.subplots(figsize=(4,4))
    p=segdata.Plot(d)
    p.plot_count(ax, d)
    mod.models[0].plot_prop(ax)
    ax.set_ylim(85,100)
    p.add_regulation(ax, d)
    name=f+'/'+str(j+4)+'_'+t+'_absolute_min_adjusted_'+str(i)+'.pdf'
    plt.savefig(name, bbox_inches='tight')
    plt.clf()
    plt.close(fig)
