import segmodels
import segdata
import numpy as np
import matplotlib.pyplot as plt
from file_list import l

if __name__ == '__main__':

    # to delete once the thing in memory works
        # ini=2e6 * 1e6 * 500 * 1e-15 # cells/uL * uL/L * fg/cell * g/fg
        # https://bionumbers.hms.harvard.edu/bionumber.aspx?id=111211&ver=4&trm=coli+dry+mass&org=
        # init=2e6 * 1e6 * 280 * 1e-15# cells/uL * uL/L * fg/cell * g/fg
        # https://bionumbers.hms.harvard.edu/search.aspx?trm=mass+e+coli

        # ini=1.8 # ~1.8 g/L at the end of the batch phase

        # initial conditions:
        #     0    1   2   3    4     5     6
        #   time,  G, A_r, G_r, Ca,   Cg, future A_r/(A_r+G_r)

    # memory:
    #             time,Ca,Cg, p, dp
    mem=np.array([[-5, 0, .01, 0, 0],
                  [ 0, 0, .01, 0, 0]])

    memo=segmodels.Memory(memory=mem)

    memo.set_regulation(segdata.Data(l[1]))
    # memo.set_regulation(segdata.Data(l[3])) # chem + seg

    model=segmodels.Model(memo, segmodels.differential.no_down())
    # model=segmodels.Model(memo, segmodels.differential.default())

    print("start running")

    model.run(80)
    # model.run(110) # for chem + seg

    print("end running")

    prop=100*model.sol[2,:]/np.sum(model.sol[1:4,:], axis=0)

    plt.figure()
    plt.plot(model.sol[0,:], prop)
    plt.figure()
    plt.plot(model.sol[0,:], model.sol[1,:], label="G")
    plt.plot(model.sol[0,:], model.sol[2,:], label="A_r")
    plt.plot(model.sol[0,:], model.sol[3,:], label="G_r")
    plt.plot(model.sol[0,:], np.sum(model.sol[1:4,:], axis=0))
    plt.figure()
    plt.plot(model.sol[0,:], model.sol[1,:]+model.sol[3,:], label="G")
    plt.plot(model.sol[0,:], model.sol[2,:], label="A")
    plt.plot(model.sol[0,:], np.sum(model.sol[1:4,:], axis=0))
    plt.legend()
    plt.figure()
    plt.plot(model.sol[0,:], model.sol[4,:], label="A")
    plt.plot(model.sol[0,:], model.sol[5,:], label="G")
    plt.legend()
    plt.title("sugars")
    plt.show()
