import segdata
import os.path
import matplotlib.pyplot as plt
# from pynfft import NFFT, Solver
import scipy.fft as fft
import scipy.signal
import numpy as np
from file_list import l


from matplotlib.widgets import Slider
from matplotlib.widgets import Button
import matplotlib.colors
import matplotlib.cm as cm


if __name__=="__main__":

    plots=[]
    for name in l:
        set=segdata.Data(name)

        #####
        # show time intervals, simple fourier transforms,
        # and artificially smoothed time evolutions
        #####

        # length=set.flow.shape[0]
        # plt.figure()
        # plt.plot(range(0,length-1), set.flow[1:,0]-set.flow[:-1,0])
        # plt.title(name+" -- Time diff")
        # j=np.searchsorted(set.flow[:,0], 0)
        # mean_dt=np.mean(set.flow[j+1:,0]-set.flow[j:-1,0])
        #
        # # make data:
        # pos=np.empty_like(set.flow[j:,5])
        # neg=np.empty_like(set.flow[j:,5])
        # tot=np.empty_like(set.flow[j:,5])
        #
        # for i, cyto in enumerate(set.flow[j:,5]):
        #     pos[i]=(cyto.count_pos(threshold=1000)/cyto.count()
        #             *set.flow[j+i,1])
        #     neg[i]=(cyto.count_neg(threshold=1000)/cyto.count()
        #             *set.flow[j+i,1])
        #     tot[i]=set.flow[j+i,1]
        #
        # f1=fft.fft(pos)
        # f2=fft.fft(neg)
        # f3=fft.fft(tot)
        # x=np.arange(0, pos.shape[0])/mean_dt/pos.shape[0]
        # plt.figure()
        #
        # # plt.plot(x,np.abs(np.real(f1)), label='GFP+')
        # # plt.plot(x,np.abs(np.real(f2)), label='GFP-')
        # # plt.plot(x,np.abs(np.real(f3)), label='tot')
        # plt.plot(x,np.abs(f1), label='GFP+')
        # plt.plot(x,np.abs(f2), label='GFP-')
        # plt.plot(x,np.abs(f3), label='tot')
        # plt.legend()
        # plt.title(name)
        # # plt.xscale('log')
        # plt.yscale('log')
        #
        # pos_filtered=scipy.signal.savgol_filter(pos, 11,3, mode='mirror')
        # tot_filtered=scipy.signal.savgol_filter(tot, 11,3, mode='mirror')
        #
        # pos_filtered[pos_filtered<0]=tot_filtered[pos_filtered<0]
        #
        # neg_filtered=tot_filtered-pos_filtered
        #
        # fig, ax= plt.subplots()
        # plt.subplots_adjust(bottom=0.15)
        # p=segdata.Plot()
        # plots.append(p)
        # p.make_slider(fig)
        # p.plot_partial_ccttion(ax, set)
        # p.plot_cyto(ax, set)
        #
        # fig, ax= plt.subplots()
        # plt.subplots_adjust(bottom=0.15)
        #
        # # ax.plot(set.flow[j:,0], pos, label='y')
        # ax.plot(set.flow[j:,0], pos_filtered, label='+')
        # ax.plot(set.flow[j:,0], neg_filtered, label='-')
        # # ax.plot(set.flow[j:,0], tot, label='tot')
        # ax.plot(set.flow[j:,0], tot_filtered, label='tot')
        #
        # # upper bound for growth rate, lower bound for switching rates
        # # that means no switching at all
        #
        # # lower bound for growth rate, upper bound for switching rates
        # # that means all switch for the smallest change
        #
        # # not possible to determine as the only apparent thing is H1-H2 and any
        # # growth could be the result of either switching or growth (including
        # # when one of them decrease, it could be that the growing one still
        # # compensates part of the decreasing one
        #
        # ax.legend()

    # plots=[]
    # for set in m:
    #     pass
    # plots.append(segdata.standard.explore(set))

        #####
        # Show difference between height and area on fluorescence time_scatter
        ####

        set.sanitize()
        fig, ax = plt.subplots(2)
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.time_scatter(ax[0], set)
        # p.time_scatter(ax[1], set, index=8, y_label='FL1-H')

        ax1=ax[1]
        list=[ax1]
        index=2
        t=[]
        d=[]
        s=[]

        prop=np.empty_like(set.flow[:,0])
        thresh_i=np.empty_like(set.flow[:,0])
        prop_i=np.empty_like(set.flow[:,0])

        for i, time in enumerate(set.flow[:, 0]):
            new_s=set.flow[i,5].cyto[:,0]
            s.append(new_s)


        s=np.concatenate(s)
        thresh=1000/np.mean(s)

        for i, time in enumerate(set.flow[:, 0]):
            new_t=time*np.ones_like(set.flow[i,5].cyto[:,index])
            new_d=set.flow[i,5].cyto[:,index]/set.flow[i,5].cyto[:,0]
            prop[i]=np.sum(new_d>=thresh)/new_d.shape[0]

            thresh_i[i]=1000/np.mean(set.flow[i,5].cyto[:,0])
            prop_i[i]=np.sum(new_d>=thresh_i[i])/new_d.shape[0]

            t.append(new_t)
            d.append(new_d)

        t=np.concatenate(t)
        d=np.concatenate(d)

        # print(max(d))
        # print(min(d))
        # exit()

        logbins = np.logspace(-5.5,1.5,100)
        timebins= (set.flow[1:, 0]+set.flow[:-1, 0])/2
        # add the two extreme bins for the time:
        timebins=np.concatenate([[2*set.flow[0, 0]-set.flow[1, 0]], timebins,
                                [2*set.flow[-1, 0]-set.flow[-2, 0]]])

        hb=ax1.hist2d(t,d, bins=[timebins, logbins],
                    norm=matplotlib.colors.LogNorm())
        hb=hb[-1]
        # cb=plt.colorbar(hb,ax=list)
        cb=plt.colorbar(cm.ScalarMappable(norm=hb.norm, cmap=hb.cmap),ax=list)

        ax1.set_xlabel('Time')
        ax1.set_ylabel('proportion')
        ax1.set_yscale('log')

        p.plot(ax1, np.array([[100,100],[100,100]]), 0)
        p.plot(ax1, np.array([[0,thresh],[85,thresh]]), 0)
        p.plot(ax1, np.stack((set.flow[:,0],thresh_i), axis=-1), 0)
        p.plot(ax[0], np.array([[0,1000],[85,1000]]), 0)


        plots.append(p)



        fig, ax = plt.subplots(1,2)
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.plot(ax[0], np.stack((set.flow[:,0], prop), axis=-1), 0)
        ax[0].plot(set.flow[:,0], 1-prop)
        ax[0].set_ylabel('prop_adapted')
        p.plot_count(ax[1], set)

        # stop plots from disappearing
        plots.append(p)


        fig, ax = plt.subplots(1,2)
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.plot(ax[0], np.stack((set.flow[:,0], prop_i), axis=-1), 0)
        ax[0].plot(set.flow[:,0], 1-prop_i)
        ax[0].set_ylabel('prop_adapted_mov')
        p.plot_count(ax[1], set)

        # stop plots from disappearing
        plots.append(p)


        fig, ax = plt.subplots(1,2)
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.plot(ax[0], np.stack((set.flow[:,0], prop*set.flow[:,1]), axis=-1), 0)
        ax[0].plot(set.flow[:,0], (1-prop)*set.flow[:,1])
        ax[0].set_ylabel('ccttion_adapted')
        p.plot_partial_ccttion(ax[1], set)

        # stop plots from disappearing
        plots.append(p)

        fig, ax = plt.subplots(1,2)
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.plot(ax[0], np.stack((set.flow[:,0], prop_i*set.flow[:,1]), axis=-1), 0)
        ax[0].plot(set.flow[:,0], (1-prop_i)*set.flow[:,1])
        ax[0].set_ylabel('ccttion_adapted_mov')
        p.plot_partial_ccttion(ax[1], set)

        # stop plots from disappearing
        plots.append(p)


        fig, ax = plt.subplots()
        p=segdata.Plot()
        plt.subplots_adjust(bottom=0.15)
        p.make_slider(fig)
        p.time_scatter(ax, set, index=0, y_label='FSC-A')

        plots.append(p)

    plt.show()
