import segdata
import numpy as np
from file_list import l
import sklearn
import sklearn.preprocessing
import sklearn.decomposition
import sklearn.cluster
import matplotlib.pyplot as plt
import matplotlib.colors
import matplotlib.cm as cm

if __name__=="__main__":

    d=[]

    for path in l:
        set=segdata.Data(path)
        set.sanitize()

        # t0=0
        t0=np.searchsorted(set.flow[:,0], 4)

        ## get the data for the PCA

        # first get the overall shape
        s=0
        for time_point in set.flow[t0:,5]:
            s+=time_point.cyto.shape[0]

        # overall_data=np.zeros((s,8))
        overall_data=np.zeros((s,10))
        # 0: Time (just in case, not needed)
        # 1: FSC-A
        # 2: SSC-A
        # 3: FL1-A
        # 4: FSC-H
        # 5: SSC-H
        # 6: FL1-H
        # 7: Width
        # 8: FL1-A/... (try different ones...)
        # 9: FL1-H/... (try different ones...)

        s=0
        # then fill up the data
        for i,time_point in enumerate(set.flow[t0:,5]):
            delta=time_point.cyto.shape[0]
            overall_data[s:s+delta,0]=set.flow[i,0]
            overall_data[s:s+delta,1:4]=time_point.cyto[:,0:3]
            overall_data[s:s+delta,4:7]=time_point.cyto[:,6:9]
            overall_data[s:s+delta,7]=time_point.cyto[:,12]
            s+=time_point.cyto.shape[0]

        # overall_data[:,8]=overall_data[:,3]/overall_data[:,7]
        # overall_data[:,9]=overall_data[:,6]/overall_data[:,7]
        overall_data[:,8]=overall_data[:,3]/overall_data[:,1]
        overall_data[:,9]=overall_data[:,6]/overall_data[:,1]

        # check everything went right
        if np.any(overall_data[1:10]==0):
            # throw exception
            # to replace
            print("error testing_PCA")
            exit()

        d.append(np.log(np.hstack((overall_data[:,1:3],
                            overall_data[:,8:9],
                            overall_data[:,4:6],
                            overall_data[:,9:10],
                            overall_data[:,7:8]))))
        # d.append(overall_data[:,1:8])

        # make PCA on [1:8]
        # make PCA on [1:3], [8], [4:8]
        # make PCA on [1:6], [9], [7]
        # make PCA on [1:3], [8], [4:6], [9], [7]
        def make_PCA(x):
            print('shape')
            print(x.shape)
            estimator=sklearn.preprocessing.StandardScaler()
            n=estimator.fit_transform(x)
            pca=sklearn.decomposition.PCA()
            k=pca.fit_transform(n)
            # print(n)
            # print(estimator.mean_)
            # print(estimator.var_)
            print("components (by line):")
            print(pca.components_)
            print("explained variance:")
            print(pca.explained_variance_/7)
            # print("transformed data")
            # plt.scatter(k[:,0], k[:,1])

        # print principal components and how much they explain
        # print("")
        # print("#### normal")
        # print("")
        # make_PCA(overall_data[:,1:8])
        # print("")
        # print("#### replaced FL1A")
        # print("")
        # make_PCA(np.hstack((overall_data[:,1:3],
        #                     overall_data[:,8:9],
        #                     overall_data[:,4:8])))
        # print("")
        # print("#### replaced FL1H")
        # print("")
        # make_PCA(np.hstack((overall_data[:,1:6],
        #                     overall_data[:,9:10],
        #                     overall_data[:,7:8])))
        # print("")
        # print("#### replaced both")
        # print("")
        # make_PCA(np.hstack((overall_data[:,1:3],
        #                     overall_data[:,8:9],
        #                     overall_data[:,4:6],
        #                     overall_data[:,9:10],
        #                     overall_data[:,7:8])))
        # print("")
        # print("####")
        # print("")

        # plt.show()

        # Not anymore:
        # # replace with division by width, FSC-H, SSC-A, SSC-H, and
        # # combinations if not too long

        # numbers seem to say it improves by 5 percents what's explained by
        # the 3rd PC → overall more explained that way, and plots show there
        # are less outliers or at least they are closer together


    # estimator=sklearn.preprocessing.StandardScaler()
    # n=estimator.fit_transform(d[0])
    # pca=sklearn.decomposition.PCA()
    # k=pca.fit_transform(n)
    # print("components (by line):")
    # print(pca.components_)
    # print("explained variance:")
    # print(pca.explained_variance_/7)
    # # y_lim=[-300,400]
    # # x_lim=[-10, 1050]
    # y_lim=[-10,20]
    # x_lim=[-10,40]
    # bin_x=np.linspace(x_lim[0],x_lim[1],5000)
    # bin_y=np.linspace(y_lim[0],y_lim[1],1000)
    # plt.hist2d(k[:,0],k[:,1], bins=[bin_x,bin_y],
    #     norm=matplotlib.colors.LogNorm())
    #
    # plt.subplots()
    # plt.hist2d(k[:,2],k[:,1], bins=[bin_x,bin_y],
    #     norm=matplotlib.colors.LogNorm())
    # # plt.scatter(k[:,0], k[:,1])
    # plt.ylim(y_lim)
    # plt.xlim(x_lim)
    # for data in d[1:3]:
    #     plt.subplots()
    #     n=estimator.transform(data)
    #     k=pca.transform(n)
    #     # plt.scatter(k[:,0], k[:,1])
    #     plt.ylim(y_lim)
    #     plt.xlim(x_lim)
    #     plt.hist2d(k[:,0],k[:,1], bins=[bin_x,bin_y],
    #         norm=matplotlib.colors.LogNorm())
    #     plt.subplots()
    #     plt.hist2d(k[:,2],k[:,1], bins=[bin_x,bin_y],
    #         norm=matplotlib.colors.LogNorm())
    #
    # plt.show()

    # try log space ! → better that way
    # use the fluorescence divided by width
    # 3 main components → use PCA of the three experiments together since time
    # doesn't influence stuff...


    ######
    # noise removal
    ######

    # transform the data into the first 3 principal components
    # apply dbscan with two non-noise clusters
    #    Check how much would be removed
    #    apply inverse transform to cluster coordinates
    # apply with 3
    # apply with 4
    # apply for only after 5 h...

    # # doing all the data runs out of RAM... dead end, tant pis

    # estimator=sklearn.preprocessing.StandardScaler()
    # n=estimator.fit_transform(d[0])
    # pca=sklearn.decomposition.PCA()
    # k=pca.fit_transform(n)
    # print("components (by line):")
    # print(pca.components_)
    # print("explained variance:")
    # print(pca.explained_variance_/7)
    #
    # # # y_lim=[-300,400]
    # # # x_lim=[-10, 1050]
    # # y_lim=[-10,20]
    # # x_lim=[-10,40]
    # # bin_x=np.linspace(x_lim[0],x_lim[1],5000)
    # # bin_y=np.linspace(y_lim[0],y_lim[1],1000)
    # # plt.hist2d(k[:,0],k[:,1], bins=[bin_x,bin_y],
    # #     norm=matplotlib.colors.LogNorm())
    # #
    # # plt.subplots()
    # # plt.hist2d(k[:,2],k[:,1], bins=[bin_x,bin_y],
    # #     norm=matplotlib.colors.LogNorm())
    # #
    # # plt.show()
    #
    # db=sklearn.cluster.DBSCAN(leaf_size=150, n_jobs=3).fit(k[:,0:3])
    #
    # print(db)
