import sympy


if __name__=="__main__":
    sympy.init_printing(use_unicode=True)

    D=sympy.symbols('D');
    H1=sympy.symbols('H1');
    H2=sympy.symbols('H2');
    mu_max_a=sympy.symbols('mu_max_a');
    mu_max_g=sympy.symbols('mu_max_g');
    Ka=sympy.symbols('Ka');
    Kg=sympy.symbols('Kg');
    Ca0=sympy.symbols('Ca0');
    Cg0=sympy.symbols('Cg0');
    A0=sympy.symbols('A0');
    G0=sympy.symbols('G0');
    Ca_in=sympy.symbols('Ca_in');
    Cg_in=sympy.symbols('Cg_in');
    Y_XA=sympy.symbols('Y_XA');
    Y_XG=sympy.symbols('Y_XG');

    alpha_A=(-D-H1)*A0+H2*G0+mu_max_a*Ca0*A0/(Ka+Ca0);
    alpha_G=(-D-H2)*G0+H1*A0+mu_max_a*Cg0*G0/(Kg+Cg0);

    beta_A=-D-H1+mu_max_a *Ca0/(Ka+Ca0);
    beta_G=-D-H2+mu_max_g *Cg0/(Kg+Cg0);

    gamma_A=mu_max_a*Ka*A0/((Ka+Ca0)**2);
    gamma_G=mu_max_g*Kg*G0/((Kg+Cg0)**2);

    o_A=(Ca_in-Ca0)*D-mu_max_a*Ca0*A0/(Y_XA*(Ka+Ca0));
    o_G=(Cg_in-Cg0)*D-mu_max_g*Cg0*G0/(Y_XG*(Kg+Cg0));

    p_A=-D-mu_max_a*Ka*A0/(Y_XA*(Ka+Ca0)**2)
    p_G=-D-mu_max_g*Kg*G0/(Y_XG*(Kg+Cg0)**2)

    q_A=-mu_max_a*Ca0/(Y_XA*(Ka+Ca0));
    q_G=-mu_max_g*Cg0/(Y_XG*(Kg+Cg0));



    mat=sympy.Matrix([[beta_A, H2, gamma_A, 0],
            [H1, beta_G, 0, gamma_G],
            [q_A, 0, p_A, 0],
            [0, q_G, 0, p_G]])

    b=[alpha_A, alpha_G, o_A, o_G]

    # x=[A, G, Ca, Cg]
    # dx/dt=mat*x + b

    # eig=mat.eigenvals()

    # print(eig)

    # print(mat.eigenvects()) # out of RAM for that line

    # critical=-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2

    # print(critical.subs([(D, 0.5),
    #             (Ca_in, 1.5),
    #             (Cg_in, 5),
    #             (H1, 0.1),
    #             (H2, 10),
    #             (mu_max_g, 0.5),
    #             (mu_max_a, 0.05),
    #             (Y_XG, 0.5),
    #             (Y_XA, 0.5),
    #             (Ka, 0.05),
    #             (Kg, 0.05),
    #             (Ca0, 0.02),
    #             (Cg0, 0.05),
    #             (A0, 15e4* 1e6 * 280 * 1e-15),
    #             (G0, 15e4* 1e6 * 280 * 1e-15)]).evalf())

    s1=-(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)/(3*(sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)) - (sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)/3 - (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)/(3*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG))
    s2=-(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)/(3*(-1/2 + sympy.sqrt(3)*sympy.I/2)*(sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)) - (-1/2 + sympy.sqrt(3)*sympy.I/2)*(sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)/3 - (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)/(3*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG))
    s3=-(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)/(3*(-1/2 - sympy.sqrt(3)*sympy.I/2)*(sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)) - (-1/2 - sympy.sqrt(3)*sympy.I/2)*(sympy.sqrt(-4*(-3*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**2/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2)**3 + (27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2 + 2*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**2)/2 + 27*(A0*Cg0**2*D**2*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*D*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*D*Ka*Y_XG*mu_max_a*mu_max_g - A0*Cg0**2*H1*Ka*Y_XG*mu_max_a*mu_max_g + 2*A0*Cg0*D**2*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*D*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a*mu_max_g - A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a*mu_max_g + A0*D**2*Ka*Kg**2*Y_XG*mu_max_a + A0*D*G0*Ka*Kg*mu_max_a*mu_max_g + A0*D*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*D*H2*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*H1*Ka*Kg*mu_max_a*mu_max_g + A0*G0*H2*Ka*Kg*mu_max_a*mu_max_g + Ca0**2*Cg0**2*D**3*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*D**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*D**2*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0**2*Cg0*D**3*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*D**2*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + Ca0**2*D**3*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*D**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*D**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*D**2*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*D*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*D*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*D*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*D*H2*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0**2*G0*H2*Kg*Y_XA*mu_max_a*mu_max_g + 2*Ca0*Cg0**2*D**3*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*D**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 4*Ca0*Cg0*D**3*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*D**2*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 2*Ca0*D**3*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D**2*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*D**2*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*D*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*D*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*D*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a - Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_a*mu_max_g + Cg0**2*D**3*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*D**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*D**2*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*D*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 2*Cg0*D**3*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*D**2*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + D**3*Ka**2*Kg**2*Y_XA*Y_XG + D**2*G0*Ka**2*Kg*Y_XA*mu_max_g + D**2*H1*Ka**2*Kg**2*Y_XA*Y_XG + D**2*H2*Ka**2*Kg**2*Y_XA*Y_XG + D*G0*H1*Ka**2*Kg*Y_XA*mu_max_g + D*G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)) - 9*(A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)*(2*A0*Cg0**2*D*Ka*Y_XG*mu_max_a + A0*Cg0**2*H1*Ka*Y_XG*mu_max_a + A0*Cg0**2*H2*Ka*Y_XG*mu_max_a - A0*Cg0**2*Ka*Y_XG*mu_max_a*mu_max_g + 4*A0*Cg0*D*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H1*Ka*Kg*Y_XG*mu_max_a + 2*A0*Cg0*H2*Ka*Kg*Y_XG*mu_max_a - A0*Cg0*Ka*Kg*Y_XG*mu_max_a*mu_max_g + 2*A0*D*Ka*Kg**2*Y_XG*mu_max_a + A0*G0*Ka*Kg*mu_max_a*mu_max_g + A0*H1*Ka*Kg**2*Y_XG*mu_max_a + A0*H2*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D**2*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H1*Y_XA*Y_XG + 2*Ca0**2*Cg0**2*D*H2*Y_XA*Y_XG - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0**2*D*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H1*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0**2*H2*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0**2*Cg0*D**2*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H1*Kg*Y_XA*Y_XG + 4*Ca0**2*Cg0*D*H2*Kg*Y_XA*Y_XG - 4*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG*mu_max_g - Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG*mu_max_a + Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 3*Ca0**2*D**2*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*G0*Kg*Y_XA*mu_max_g + 2*Ca0**2*D*H1*Kg**2*Y_XA*Y_XG + 2*Ca0**2*D*H2*Kg**2*Y_XA*Y_XG - 2*Ca0**2*D*Kg**2*Y_XA*Y_XG*mu_max_a + Ca0**2*G0*H1*Kg*Y_XA*mu_max_g + Ca0**2*G0*H2*Kg*Y_XA*mu_max_g - Ca0**2*G0*Kg*Y_XA*mu_max_a*mu_max_g - Ca0**2*H2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H1*Ka*Y_XA*Y_XG + 4*Ca0*Cg0**2*D*H2*Ka*Y_XA*Y_XG - 2*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG*mu_max_g - Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG*mu_max_a + Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a*mu_max_g + 12*Ca0*Cg0*D**2*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H1*Ka*Kg*Y_XA*Y_XG + 8*Ca0*Cg0*D*H2*Ka*Kg*Y_XA*Y_XG - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_a - 4*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG*mu_max_g - 2*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG*mu_max_a + Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a*mu_max_g + 6*Ca0*D**2*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*G0*Ka*Kg*Y_XA*mu_max_g + 4*Ca0*D*H1*Ka*Kg**2*Y_XA*Y_XG + 4*Ca0*D*H2*Ka*Kg**2*Y_XA*Y_XG - 2*Ca0*D*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 2*Ca0*G0*H1*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*G0*H2*Ka*Kg*Y_XA*mu_max_g - Ca0*G0*Ka*Kg*Y_XA*mu_max_a*mu_max_g - Ca0*H2*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D**2*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H1*Ka**2*Y_XA*Y_XG + 2*Cg0**2*D*H2*Ka**2*Y_XA*Y_XG - 2*Cg0**2*D*Ka**2*Y_XA*Y_XG*mu_max_g - Cg0**2*H1*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D**2*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H1*Ka**2*Kg*Y_XA*Y_XG + 4*Cg0*D*H2*Ka**2*Kg*Y_XA*Y_XG - 2*Cg0*D*Ka**2*Kg*Y_XA*Y_XG*mu_max_g - Cg0*H1*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D**2*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*G0*Ka**2*Kg*Y_XA*mu_max_g + 2*D*H1*Ka**2*Kg**2*Y_XA*Y_XG + 2*D*H2*Ka**2*Kg**2*Y_XA*Y_XG + G0*H1*Ka**2*Kg*Y_XA*mu_max_g + G0*H2*Ka**2*Kg*Y_XA*mu_max_g)/(2*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**2) + (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)**3/(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG)**3)**(1/3)/3 - (A0*Cg0**2*Ka*Y_XG*mu_max_a + 2*A0*Cg0*Ka*Kg*Y_XG*mu_max_a + A0*Ka*Kg**2*Y_XG*mu_max_a + 3*Ca0**2*Cg0**2*D*Y_XA*Y_XG + Ca0**2*Cg0**2*H1*Y_XA*Y_XG + Ca0**2*Cg0**2*H2*Y_XA*Y_XG - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0**2*Y_XA*Y_XG*mu_max_g + 6*Ca0**2*Cg0*D*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H1*Kg*Y_XA*Y_XG + 2*Ca0**2*Cg0*H2*Kg*Y_XA*Y_XG - 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_a - Ca0**2*Cg0*Kg*Y_XA*Y_XG*mu_max_g + 3*Ca0**2*D*Kg**2*Y_XA*Y_XG + Ca0**2*G0*Kg*Y_XA*mu_max_g + Ca0**2*H1*Kg**2*Y_XA*Y_XG + Ca0**2*H2*Kg**2*Y_XA*Y_XG - Ca0**2*Kg**2*Y_XA*Y_XG*mu_max_a + 6*Ca0*Cg0**2*D*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H1*Ka*Y_XA*Y_XG + 2*Ca0*Cg0**2*H2*Ka*Y_XA*Y_XG - Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG*mu_max_g + 12*Ca0*Cg0*D*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H1*Ka*Kg*Y_XA*Y_XG + 4*Ca0*Cg0*H2*Ka*Kg*Y_XA*Y_XG - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_a - 2*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG*mu_max_g + 6*Ca0*D*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*G0*Ka*Kg*Y_XA*mu_max_g + 2*Ca0*H1*Ka*Kg**2*Y_XA*Y_XG + 2*Ca0*H2*Ka*Kg**2*Y_XA*Y_XG - Ca0*Ka*Kg**2*Y_XA*Y_XG*mu_max_a + 3*Cg0**2*D*Ka**2*Y_XA*Y_XG + Cg0**2*H1*Ka**2*Y_XA*Y_XG + Cg0**2*H2*Ka**2*Y_XA*Y_XG - Cg0**2*Ka**2*Y_XA*Y_XG*mu_max_g + 6*Cg0*D*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H1*Ka**2*Kg*Y_XA*Y_XG + 2*Cg0*H2*Ka**2*Kg*Y_XA*Y_XG - Cg0*Ka**2*Kg*Y_XA*Y_XG*mu_max_g + 3*D*Ka**2*Kg**2*Y_XA*Y_XG + G0*Ka**2*Kg*Y_XA*mu_max_g + H1*Ka**2*Kg**2*Y_XA*Y_XG + H2*Ka**2*Kg**2*Y_XA*Y_XG)/(3*(Ca0**2*Cg0**2*Y_XA*Y_XG + 2*Ca0**2*Cg0*Kg*Y_XA*Y_XG + Ca0**2*Kg**2*Y_XA*Y_XG + 2*Ca0*Cg0**2*Ka*Y_XA*Y_XG + 4*Ca0*Cg0*Ka*Kg*Y_XA*Y_XG + 2*Ca0*Ka*Kg**2*Y_XA*Y_XG + Cg0**2*Ka**2*Y_XA*Y_XG + 2*Cg0*Ka**2*Kg*Y_XA*Y_XG + Ka**2*Kg**2*Y_XA*Y_XG))


    print(s1.subs([(D, 0.5),
                (Ca_in, 1.5),
                (Cg_in, 5),
                (H1, 1),
                (H2, 1),
                (mu_max_g, 0.5),
                (mu_max_a, 5),
                (Y_XG, 0.5),
                (Y_XA, 0.5),
                (Ka, 0.05),
                (Kg, 0.05),
                (Ca0, 0.02),
                (Cg0, 0.05),
                (A0, 15e4* 1e6 * 280 * 1e-15),
                (G0, 15e4* 1e6 * 280 * 1e-15)]).evalf())
    print(s2.subs([(D, 0.5),
                (Ca_in, 1.5),
                (Cg_in, 5),
                (H1, 1),
                (H2, 1),
                (mu_max_g, 0.5),
                (mu_max_a, 5),
                (Y_XG, 0.5),
                (Y_XA, 0.5),
                (Ka, 0.05),
                (Kg, 0.05),
                (Ca0, 0.02),
                (Cg0, 0.05),
                (A0, 15e4* 1e6 * 280 * 1e-15),
                (G0, 15e4* 1e6 * 280 * 1e-15)]).evalf())
    print(s3.subs([(D, 0.5),
                (Ca_in, 1.5),
                (Cg_in, 5),
                (H1, 1),
                (H2, 1),
                (mu_max_g, 0.5),
                (mu_max_a, 5),
                (Y_XG, 0.5),
                (Y_XA, 0.5),
                (Ka, 0.05),
                (Kg, 0.05),
                (Ca0, 0.02),
                (Cg0, 0.05),
                (A0, 15e4* 1e6 * 280 * 1e-15),
                (G0, 15e4* 1e6 * 280 * 1e-15)]).evalf())
